/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.Element;
import core.Node;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

/**
 *
 * @author pchr
 */
public class DrawPanelInput extends DrawPanel{
    private boolean def=false;
    private int sit=1;

    public DrawPanelInput() {
        super();
    }


    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.BLACK);
	g2.clearRect(0, 0, width, height);
        
        g2.setColor(Color.GRAY);
        
        xs=width/10;
        xe=width-width/10;
        ye=height/10;
        ys=height-height/10;
        
        g2.setStroke(new BasicStroke(1));
        //g2.drawLine(xs, ys, xe/2, ys);
        //g2.drawLine(xe/2, ys, xe, ys);
        
        if(this.frame!=null){
            this.drawElements(g2);
            this.drawNodes(g2);
            if(def){this.drawDefElements(g2);}
        }
        
    }
    
    public void drawElements(Graphics2D g2){
        int x1,x2,y1,y2;
        Element[] theElements  = this.frame.getElements();
        for(int i=0; i<theElements.length; i++){
            Element theElement = theElements[i];
            x1=this.xTransformation(theElement.getN1().getX());
            x2=this.xTransformation(theElement.getN2().getX());
            y1=this.yTransformation(theElement.getN1().getY());
            y2=this.yTransformation(theElement.getN2().getY());

            g2.setColor(Color.GREEN);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
            g2.setStroke(new BasicStroke(1));
            int elid=theElement.getId();
            int storey=0;
            if(elid==3 || elid==6 || elid==9){
                if(elid==3)storey=1;if(elid==6)storey=2;if(elid==9)storey=3;
                g2.drawString(Integer.toString(storey), (x1+x2)/2-15, (y1+y2)/2-15);
            }
        }
    }
    
    public void drawDefElements(Graphics2D g2){
        int x1,x2,y1,y2;
        double x0,x01;
        int split=1;
        g2.setColor(Color.ORANGE);
        g2.setStroke(new BasicStroke(1));
        //Element[] theElements  = this.frame.getElements();
        for(int i=0; i<this.frame.getElements().length; i++){
            //Element theElement = theElements[i];
            
            x1=this.xTransformation(this.frame.getDefElement(i+1, -1., sit).get(0, 0));
            y1=this.yTransformation(this.frame.getDefElement(i+1, -1., sit).get(1, 0));
            x0= -1.+ (double)1*2./split;
            x2=this.xTransformation(this.frame.getDefElement(i+1, x0, sit).get(0, 0));
            y2=this.yTransformation(this.frame.getDefElement(i+1, x0, sit).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            if(split>2){
                for(int j=1; j<split-1; j++){
                    x0= -1.+ (double)j*2./split;
                    x01= -1.+ (double)(j+1)*2./split;
                    x1=this.xTransformation(this.frame.getDefElement(i+1, x01, sit).get(0, 0));
                    y1=this.yTransformation(this.frame.getDefElement(i+1, x01, sit).get(1, 0));
                    x2=this.xTransformation(this.frame.getDefElement(i+1, x0, sit).get(0, 0));
                    y2=this.yTransformation(this.frame.getDefElement(i+1, x0, sit).get(1, 0));
                    g2.drawLine(x1, y1, x2, y2);
                }
            }
            x0= -1.+ (double)(split-1)*2./split;
            x1=this.xTransformation(this.frame.getDefElement(i+1, x0, sit).get(0, 0));
            y1=this.yTransformation(this.frame.getDefElement(i+1, x0, sit).get(1, 0));
            x2=this.xTransformation(this.frame.getDefElement(i+1, 1., sit).get(0, 0));
            y2=this.yTransformation(this.frame.getDefElement(i+1, 1., sit).get(1, 0));
            g2.drawLine(x1, y1, x2, y2);
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            String sd1,sd2;
            sd1=Places.format(frame.getEigPeriod(sit));
            sd2=Places.format(2.*Math.PI/frame.getEigPeriod(sit));
            g2.drawString("Ιδιομορφή "+Integer.toString(sit)+", T="+sd1+", ω="+sd2, 10, 20);
            }
    }
    
    public void drawNodes(Graphics2D g2){
        int x1,y1;
        Node[] theNodes  = this.frame.getNodes();
        g2.setColor(Color.RED);
        g2.setStroke(new BasicStroke(1));
        for(int i=0; i<theNodes.length; i++){
            Node theNode = theNodes[i];
            x1=this.xTransformation(theNode.getX());
            y1=this.yTransformation(theNode.getY());
            //g2.drawLine(x1-5, y1-5, x1+5, y1+5);
            //g2.drawLine(x1-5, y1+5, x1+5, y1-5);
            g2.fillArc(x1-1, y1-1, 4, 4, 0, 360);
            //g2.drawString(Integer.toString(theNode.getId()), x1-10, y1+20);
        }
    }
    
    public void setDef(boolean flag){
        def=flag;
    }
    
    public void setSit(int sit){
        this.sit=sit;
    }
    
    public int getSit(){
        return this.sit;
    }
}
